﻿using System;
using System.Collections.Generic;
using BioLab.ImageProcessing;
using BioLab.Common;
using BioLab.Math.LinearAlgebra;
using BioLab.DimensionalityReduction;
using BioLab.Biometrics.Face;
using BioLab.Biometrics.Common;

namespace FaceRecognition
{
    public class MyEigenfaceLeftEnroller : Enroller<FaceSet, EigenfaceTemplate>
    {
        public FaceFeatureExtractor FeatureExtractor { get; set; }
        public KLTransform KL { get; set; }
        
        public MyEigenfaceLeftEnroller()
        {
        }
        
        public static MyEigenfaceLeftEnroller Train(ICollection<Image<byte>> Samples, FaceFeatureExtractor featureExtractor, int subspaceDimensionality)
        {
            throw new NotImplementedException();
        }

        public void SaveTrainingToFile(string path)
        {
            KL.SaveToFile(path);
        }

        public static MyEigenfaceLeftEnroller FromFile(string path, FaceFeatureExtractor featureExtractor)
        {
            MyEigenfaceLeftEnroller enroller = new MyEigenfaceLeftEnroller();
            enroller.FeatureExtractor = featureExtractor;
            enroller.KL = KLTransform.LoadFromFile(path);
            return enroller;
        }

        public override void Run()
        {
            throw new NotImplementedException();
        }
    }

    public class MyEigenfaceRightEnroller : Enroller<Image<byte>, Vector>
    {
        public FaceFeatureExtractor FeatureExtractor { get; set; }
        public KLTransform KL { get; set; }

        public MyEigenfaceRightEnroller()
        {
        }

        public MyEigenfaceRightEnroller(KLTransform kl, FaceFeatureExtractor featureExtractor)
        {
            KL = kl;
            FeatureExtractor = featureExtractor;
        }

        public override void Run()
        {
            throw new NotImplementedException();
        }

        public static MyEigenfaceRightEnroller FromFile(string path, FaceFeatureExtractor featureExtractor)
        {
            MyEigenfaceRightEnroller enroller = new MyEigenfaceRightEnroller();
            enroller.FeatureExtractor = featureExtractor;
            enroller.KL = KLTransform.LoadFromFile(path);
            return enroller;
        }
    }
    
    public class MyEigenfaceMatcher : Matcher<EigenfaceTemplate, Vector>
    {
        public override void Run()
        {
            throw new NotImplementedException();
        }
    }
}
